#include <stdexcept>
#include <sstream>

#include "AsmError.h"


AsmError::AsmError(const AsmError& pe) : std::runtime_error("") {
    m_message.str(pe.m_message.str());
}


AsmError::AsmError(const char *msg) : std::runtime_error("") {
    m_message << msg;
}


AsmError::AsmError(int line, const char *msg) : std::runtime_error("") {
    m_message << "Line ";
    m_message << line;
    m_message << ": ";
    m_message << msg;
}


AsmError::AsmError(const char *name, int line, const char *msg)
: std::runtime_error("") {
    m_message << name;
    m_message << ", line ";
    m_message << line;
    m_message << ": ";
    m_message << msg;
}


const char *AsmError::what() const throw() {
    return m_message.str().c_str();
}
