#include "Compressor.h"


std::auto_ptr<Compressor> CompressorFactory::get_compressor(Compressor::compression_type ct) {
    switch (ct) {
        case Compressor::LZSS:
        return std::auto_ptr<Compressor>(new LZSSCompressor());
        
        case Compressor::NONE:
        return std::auto_ptr<Compressor>(new NoneCompressor());
        
        case Compressor::PUCRUNCH:
        case Compressor::EXOMIZER:
        default:
        throw CompressorException("compressor unimplemented");
    }
}
