#include "File.h"
#include "Image.h"


Image::Image(const char *filename)
: m_filename(filename) {
    
}


int Image::load(void) {
    char la_buffer[2];
    int mem_index;
    int load_address;
    std::streamsize file_len;
    byte_t *buffer;
    
    try {
        File file(m_filename, File::READ, File::BINARY);

        if (file.read(&la_buffer[0], 2) != 2) {
            throw ImageException("couldn't read load address");
        }
        load_address = la_buffer[0] | (la_buffer[1] << 8);
        mem_index = load_address;
        file_len = file.data_left();
        
        if ((buffer = m_mem.get_valid_range_ptr(load_address, load_address + file_len - 1)) == NULL) {
            throw ImageException("file loads outside of available memory");
        }
        
        file.read((char *)buffer, file_len);
        m_mem.set_hi_lo(load_address, load_address + file_len - 1);
    }
    catch (FileException& e) {
        throw ImageException(e.what());
    }
    
    return file_len;
}
