/*

Multicolor Bitmap Mode

$0a00-$0axx     code
$3fff           background color
$4000-$5f3f     bitmap
$6000-$63e7     screen ram
$6400-$67e7     color ram

*/


#include <iostream>

#include "Asm6502.h"
#include "Image.h"


static const char *mcb_viewer[] = {
    " ldx #$00",
    " stx $d020",
    "copycolor:",
    " lda $6400,x",
    " sta $d800,x",
    " lda $6500,x",
    " sta $d900,x",
    " lda $6600,x",
    " sta $da00,x",
    " lda $6700,x",
    " sta $db00,x",
    " inx",
    " bne copycolor",
    "",
    " lda $3fff",
    " sta $d021",
    " lda #$3b",
    " sta $d011",
    " lda #$d8",
    " sta $d016",
    "",
    " lda $dd00",
    " and #$fc",
    " ora #$02",
    " sta $dd00",
    " lda #$80",
    " sta $d018",
    "",
    " sei",
    " lda #$7f",
    " sta $dc00",
    " lda #$ef",
    "waitspace:",
    " cmp $dc01",
    " bne waitspace",
    " cli",
    "",
    " brk",
    NULL
};


void MulticolorBitmapImage::assemble(void) {
    Asm6502 assembler("mcb_viewer", mcb_viewer);
    
    try {
        assembler.assemble(0x0a00, m_mem);
    }
    catch (AsmError& e) {
        std::cerr << e.what() << std::endl;
        throw ImageException("couldn't assemble multicolor bitmap display code");
    }
}
