#include <string>
#include <sstream>
#include <iomanip>

#include "format.h"


std::string format_hex(int hex, int size = 0) {
    std::stringstream ss;
    
    ss << "$";
    if (size) {
        ss << std::setw(size) << std::setfill('0');
    }
    ss << std::hex << hex;
    return ss.str();
}


std::string format_string(std::string& str, int width) {
    std::stringstream ss;
    
    ss << std::setw(width) << std::left << str;
    return ss.str();
}
