#include <iostream>

#include "global.h"
#include "output.h"


/*
class NullBuf : public std::streambuf {
    int overflow(int c) { return c; };
};
*/


static std::ostream out(0);


std::ostream& output(GlobalPref::verbosity_level verbosity) {
    if (verbosity == GlobalPref::SILENT) {
        throw "trying to output a SILENT message";
    }
    if (verbosity <= global_pref.verbosity) {
        return std::cout;
    } else {
        return out;
    }
}


std::ostream& debug_out(void) {
    return output(GlobalPref::DEBUG);
}


std::ostream& verbose_out(void) {
    return output(GlobalPref::VERBOSE);
}


std::ostream& info_out(void) {
    return output(GlobalPref::INFO);
}
